Part (Servlet 4.0 API Documentation - Apache Tomcat 9.0.111)
Description: declaration: package: javax.servlet.http, interface: Part

# Interface Part

public interface Part
This class represents a part as uploaded to the server as part of a `multipart/form-data` request body. The part may represent either an uploaded file or form data.

Since:
  Servlet 3.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `delete()`
  Deletes the underlying storage for a part, including deleting any associated temporary disk file.
  `String`
  `getContentType()`
  Obtain the content type passed by the browser.
  `String`
  `getHeader(String name)`
  Obtains the value of the specified part header as a String.
  `Collection<String>`
  `getHeaderNames()`
  Get the header names provided for this part.
  `Collection<String>`
  `getHeaders(String name)`
  Obtain all the values of the specified part header.
  `InputStream`
  `getInputStream()`
  Obtain an `InputStream` that can be used to retrieve the contents of the file.
  `String`
  `getName()`
  Obtain the name of the field in the multipart form corresponding to this part.
  `long`
  `getSize()`
  Obtain the size of this part.
  `String`
  `getSubmittedFileName()`
  If this part represents an uploaded file, gets the file name submitted in the upload.
  `void`
  `write(String fileName)`
  A convenience method to write an uploaded part to disk.

- ## Method Details

  - ### getInputStream

    InputStream getInputStream() throws IOException
    Obtain an `InputStream` that can be used to retrieve the contents of the file.
    Returns:
      An InputStream for the contents of the file
    Throws:
      `IOException` - if an I/O occurs while obtaining the stream

  - ### getContentType

    String getContentType()
    Obtain the content type passed by the browser.
    Returns:
      The content type passed by the browser or `null` if not defined.

  - ### getName

    String getName()
    Obtain the name of the field in the multipart form corresponding to this part.
    Returns:
      The name of the field in the multipart form corresponding to this part.

  - ### getSubmittedFileName

    String getSubmittedFileName()
    If this part represents an uploaded file, gets the file name submitted in the upload. Returns `null` if no file name is available or if this part is not a file upload.
    Returns:
      the submitted file name or `null`.
    Since:
      Servlet 3.1

  - ### getSize

    long getSize()
    Obtain the size of this part.
    Returns:
      The size of the part if bytes

  - ### write

    void write(String fileName) throws IOException
    A convenience method to write an uploaded part to disk. The client code is not concerned with whether or not the part is stored in memory, or on disk in a temporary location. They just want to write the uploaded part to a file. This method is not guaranteed to succeed if called more than once for the same part. This allows a particular implementation to use, for example, file renaming, where possible, rather than copying all of the underlying data, thus gaining a significant performance benefit.
    Parameters:
      `fileName` - The location into which the uploaded part should be stored. Relative locations are relative to `MultipartConfigElement.getLocation()`
    Throws:
      `IOException` - if an I/O occurs while attempting to write the part

  - ### delete

    void delete() throws IOException
    Deletes the underlying storage for a part, including deleting any associated temporary disk file. Although the container will delete this storage automatically this method can be used to ensure that this is done at an earlier time, thus preserving system resources.

    Containers are only required to delete the associated storage when the Part instance is garbage collected. Apache Tomcat will delete the associated storage when the associated request has finished processing. Behaviour of other containers may be different.

    Throws:
      `IOException` - if an I/O occurs while attempting to delete the part

  - ### getHeader

    String getHeader(String name)
    Obtains the value of the specified part header as a String. If there are multiple headers with the same name, this method returns the first header in the part. The header name is case insensitive.
    Parameters:
      `name` - Header name
    Returns:
      The header value or `null` if the header is not present

  - ### getHeaders

    Collection<String> getHeaders(String name)
    Obtain all the values of the specified part header.
    Parameters:
      `name` - The name of the header of interest. The header name is case insensitive.
    Returns:
      All the values of the specified part header. If the part did not include any headers of the specified name, this method returns an empty Collection.

  - ### getHeaderNames

    Collection<String> getHeaderNames()
    Get the header names provided for this part.
    Returns:
      a Collection of all the header names provided for this part.